(defun c:roof-2chk-nnnnnnnnnn-s ( / *error* vl-load rlw unioncollinearplaneprints unique inside-p distp2t _vl-sort numbpos offd chkcircinside-dist chkcircinside collinear-pp searchipss processlil process ti s dm lw lwi pl ppl pli tl utl lst llst lstt ll zz x y ip ips ipss pos ang flag d t1 t2 tt1 tt2 tt k n att pll lil lilx lil1 lil2 )

  (defun *error* ( m )
    ;(command-s "_.-OVERKILL" "_ALL" "" "_T" "_Y" "")
    (if (and lwi (not (vlax-erased-p lwi)))
      (if (= (type lwi) (quote ename))
        (entdel lwi)
        (vla-delete lwi)
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (vl-cmdf "_.UNDO" "_E"))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (prompt "\nElapsed time : ") (prompt (rtos (- (car (_vl-times)) ti) 2 20)) (prompt " milliseconds...")
    (prompt "\nFor UNDO - type \"UNDO\" - \"Back\" option...")
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun vl-load nil
    (or cad
      (if vlax-get-acad-object
        (setq cad (vlax-get-acad-object))
        (progn
          (vl-load-com)
          (setq cad (vlax-get-acad-object))
        )
      )
    )
    (or doc (setq doc (vla-get-activedocument cad)))
    (or alo (setq alo (vla-get-activelayout doc)))
    (or spc (setq spc (vla-get-block alo)))
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond
            ( (= (car a1) 10) (setq x2 (cons a1 x2)) )
            ( (= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)) )
            ( (= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)) )
            ( (= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)) )
            ( (= (car a1) 210) (setq x6 (cons a1 x6)) )
            ( t (setq x1 (cons a1 x1)) )
          )
        )
        (entmod
          (append (reverse x1)
            (append
              (apply (function append)
                (apply (function mapcar)
                  (cons (function list)
                    (list x2
                      (cdr (reverse (cons (car x3) (reverse x3))))
                      (cdr (reverse (cons (car x4) (reverse x4))))
                      (cdr (reverse (cons (car x5) (reverse x5))))
                    )
                  )
                )
              )
              x6
            )
          )
        )
        (entupd lw)
      )
    )
  )

  (defun unioncollinearplaneprints ( tl / a b tll )
    (while (setq a (car tl))
      (setq b (vl-remove-if-not (function (lambda ( x ) (and (collinear-pp (car a) (cadr a) (car x)) (collinear-pp (car a) (cadr a) (cadr x))))) tl))
      (setq tll (cons a tll))
      (if b
        (setq tl (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) b))) tl))
        (setq tl (cdr tl))
      )
    )
    tll
  )

  (defun unique ( lst / a ll )
    (while (setq a (car lst))
      (if (vl-some (function (lambda ( x ) (equal x a 1e-2))) (cdr lst))
        (setq ll (cons a ll) lst (vl-remove-if (function (lambda ( x ) (equal x a 1e-2))) (cdr lst)))
        (setq ll (cons a ll) lst (cdr lst))
      )
    )
    (reverse ll)
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun distp2t ( p gg / i d )
    (if (setq i (inters p (polar p (+ (angle (car gg) (cadr gg)) (* 0.5 pi)) 1.0) (car gg) (cadr gg) nil))
      (setq d (distance p i))
    )
  )

  (defun _vl-sort ( lst func )
    (mapcar
      (function (lambda ( x ) (nth x lst)))
      (vl-sort-i lst func)
    )
  )

  (defun numbpos ( n len )
    (cond
      ( (< n len)
        n
      )
      ( (> n len)
        (- n len)
      )
      ( t 0 )
    )
  )

  (defun offd ( ip tl / ff d dl )

    (defun ff ( ip d )
      (if (not (chkcircinside-dist ip d))
        (progn
          (setq dl (vl-remove-if (function (lambda ( x ) (equal d x 1e-6))) dl))
          (ff ip
            (setq d
              (vl-some
                (function
                  (lambda ( x )
                    (if
                      (>
                        (-
                          (length dl)
                          (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-5))) dl))
                        ) 2
                      )
                      x
                    )
                  )
                )
                (_vl-sort dl (function >))
              )
            )
          )
        )
        d
      )
    )

    (setq dl
      (mapcar
        (function
          (lambda ( x )
            (distance ip
              (inters
                ip
                (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
                (car x)
                (polar (car x) (angle (car x) (cadr x)) 1.0)
                nil
              )
            )
          )
        )
        tl
      )
    )
    (setq d
      (vl-some
        (function
          (lambda ( x )
            (if
              (>
                (-
                  (length dl)
                  (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-5))) dl))
                ) 2
              )
              x
            )
          )
        )
        (_vl-sort dl (function >))
      )
    )
    (ff ip d)
  )

  (defun chkcircinside-dist ( pp dist / ci ipp ippl params pts tst )
    (if (and pp dist)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 dist))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) (quote intersectwith) (vlax-ename->vla-object lw) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (list 0.0 (/ pi 6.0) (/ pi 3.0) (* 0.5 pi) (* 2.0 (/ pi 3.0)) (* 5.0 (/ pi 6.0)) pi (* 7.0 (/ pi 6.0)) (* 4.0 (/ pi 3.0)) (* 1.5 pi) (* 5.0 (/ pi 3.0)) (* 11.0 (/ pi 6.0))))
            (if ippl
              (setq params (append params (mapcar (function (lambda ( x ) (vlax-curve-getparamatpoint ci x))) ippl)))
            )
            (setq pts (apply (function append) (mapcar (function (lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.1)) (vlax-curve-getpointatparam ci (+ x 0.1))))) params)))
            (if (vl-every (function (lambda ( x ) (inside-p x lw lwi))) pts)
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply (function and) tst)
  )

  (defun chkcircinside ( pp tll / dd )
    (if (and pp tll)
      (if (setq dd (offd pp tll))
        (chkcircinside-dist pp dd)
      )
    )
  )

  (defun collinear-pp ( p1 p2 p3 )
    ( (lambda ( a b c )
        (or
          (equal (+ a b) c 1e-8)
          (equal (+ b c) a 1e-8)
          (equal (+ c a) b 1e-8)
        )
      )
      (distance p1 p2) (distance p2 p3) (distance p1 p3)
    )
  )

  (defun searchipss ( lst lstt / x y ip d dm ipss )
    (setq ll lst dm 1e+308)
    (if (setq x (car lstt))
      (progn
        (setq ll (vl-remove-if (function (lambda ( z ) (vl-some (function (lambda ( a ) (equal (car z) a 1e-6))) (mapcar (function cadr) lil)))) ll))
        (while (setq y (car ll)) 
          (setq ll (cdr ll))
          (if
            (and x y 
              (setq ip (inters (car x) (polar (car x) (cadr x) 1.0) (car y) (polar (car y) (cadr y) 1.0) nil))
              (not (equal ip (car x) 1e-6))
              (not (equal ip (car y) 1e-6))
            )
            (if (not (equal (setq d (distance ip (caar lil))) 0.0 1e-3))
              (if (and d (< d dm) (chkcircinside ip utl))
                (setq ipss (list ip x y) dm d)
              )
            )
          )
        )
      )
    )
    (list ipss lst lstt)
  )

  (defun processlil ( t1 t2 ipss / ang ips ip lilx )
    (if (and t1 t2 ipss (not (equal t1 t2 1e-6)))
      (progn
        (if (setq ip (inters (car t1) (cadr t1) (car t2) (cadr t2) nil))
          (setq ang (angle (car ipss) ip))
        )
        (setq ips (list (car ipss) ang t1 t2))
        (if ips
          (progn
            (setq lstt (cons ips lstt))
            (foreach p pl
              (if (equal (angle p (car ips)) (cadr (assoc p lst)) 1e-6)
                (if (not (vl-position (list (car ips) p) lil))
                  (setq lilx (cons (list (car ips) p) lilx))
                )
              )
            )
            (if (not (vl-position (list (car ips) (caar lil)) lil))
              (setq lilx (cons (list (car ips) (caar lil)) lilx))
            )
          )
        )
      )
    )
    (if lilx
      lilx
    )
  )

  (defun process ( lst att / done flag ll ip x y ips ipss ipssx d pos zz dm lilx tt t1 tt1 t2 tt2 k )
    (progn
      (while (not done)
        (setq ips nil)
        (if (not flag)
          (progn
            (setq ll lst ips nil dm 1e+308)
            (while (setq x (car ll))
              (setq ll (cdr ll))
              (setq y (car ll))
              (if (and x y (setq ip (inters (car x) (polar (car x) (cadr x) 1.0) (car y) (polar (car y) (cadr y) 1.0) nil)) (inside-p ip lw lwi))
                (if (< (setq d (min (distp2t ip (caddr x)) (distp2t ip (last y)))) dm)
                  (setq ips (list ip x y) dm d)
                )
              )
            )
            (setq pos (vl-position (cadr ips) lst))
            (if pos
              (repeat (numbpos pos (length pl))
                (setq lst (append (cdr lst) (list (car lst))))
                (setq tl (append (cdr tl) (list (car tl))))
                (setq pl (append (cdr pl) (list (car pl))))
                (setq pli (append (cdr pli) (list (car pli))))
              )
            )
            (setq tt (vl-remove-if (function (lambda ( x ) (= (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-6))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips))))) 2))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips)))))
            (setq zz (car (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) tt))) (list (caddr (cadr ips)) (cadddr (cadr ips)) (caddr (caddr ips)) (cadddr (caddr ips))))))
            (setq tl (vl-remove-if (function (lambda ( x ) (equal x zz 1e-6))) tl))
            (if (and (car ips) (car (cadr ips)) (car (caddr ips)))
              (if (= att 1)
                (progn
                  (setq lil (cons (list (car ips) (car (caddr ips))) lil))
                  (setq lil (cons (list (car ips) (car (cadr ips))) lil))
                )
                (progn
                  (setq lil (cons (list (car ips) (car (cadr ips))) lil))
                  (setq lil (cons (list (car ips) (car (caddr ips))) lil))
                )
              )
            )
            (setq ang (angle (car ips) (inters (caar tt) (cadar tt) (caadr tt) (cadadr tt) nil)))
            (setq lstt (cons (list (car ips) ang (car tt) (cadr tt)) lstt))
          )
        )
        (setq n (length tl))
        (setq tl (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (vl-some (function (lambda ( z ) (or (and (not (equal y z 1e-6)) (equal (list y z) x 1e-6)) (and (not (equal y z 1e-6)) (equal (list z y) x 1e-6))))) (mapcar (function cadr) lil)))) (mapcar (function cadr) lil)))) tl))
        (if (= n (length tl))
          (if
            (or
              (vl-some (function (lambda ( x ) (equal x (last tl) 1e-6))) (mapcar (function car) (mapcar (function cddr) lstt)))
              (equal (vl-some (function (lambda ( x ) (vl-some (function (lambda ( a ) (vl-some (function (lambda ( b ) (if (equal x (if (equal a b 1e-6) a) 1e-6) x))) (cddr (car lstt))))) (cddr (cadr lstt))))) tl) (last tl) 1e-6)
            )
            (setq tl (reverse (cdr (reverse tl))))
            (setq tl (cdr tl))
          )
        )
        (setq flag t)
        (if (not k)
          (setq k 1)
          (setq k (1+ k))
        )
        (cond
          ( (and t1 (vl-position t1 tl) (vl-every (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) (mapcar (function cadr) lil)))) t1))
            (setq tl (vl-remove t1 tl))
          )
          ( (and t2 (vl-position t2 tl) (vl-every (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) (mapcar (function cadr) lil)))) t2))
            (setq tl (vl-remove t2 tl))
          )
        )
        (setq t1 (car tl))
        (setq t2 (last tl))
        (setq ipss nil)
        (setq ipssx (searchipss lst lstt))
        (setq ipss (car ipssx))
        (setq lst (cadr ipssx))
        (setq lstt (caddr ipssx))
        (if (not ipss)
          (progn
            (setq ipssx (searchipss (reverse lst) lstt))
            (setq ipss (car ipssx))
            (setq lst (cadr ipssx))
            (setq lstt (caddr ipssx))
          )
        )
        (if ipss
          (progn
            (setq tt1 t1 tt2 t2)
            (setq lilx (processlil t1 t2 ipss))
            (setq t1 tt1 t2 tt2)
            (if lilx
              (setq lil (append lilx lil))
              (setq t1 nil t2 nil)
            )
          )
        )
        (if
          (or
            (= k (* 2 (length pl)))
            (vl-every (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) (mapcar (function cadr) lil)))) pl)
          )
          (setq done t)
        )
      )
      (unique lil)
    )
  )

  (or (and cad doc alo spc) (vl-load))
  (while (= 8 (logand 8 (getvar (quote undoctl))))
    (if (not (vl-cmdf "_.UNDO" "_E"))
      (if doc
        (vla-endundomark doc)
      )
    )
  )
  (if (not (vl-cmdf "_.UNDO" "_BE"))
    (if doc
      (vla-startundomark doc)
    )
  )
  (prompt "\nPick closed polygonal LWPOLYLINE on unlocked layer...")
  (if (setq s (ssget "_+.:E:S:L" (list (cons 0 "LWPOLYLINE") (cons -4 "&=") (cons 70 1) (cons -4 "<not") (cons -4 "<>") (cons 42 0.0) (cons -4 "not>"))))
    (progn
      (setq ti (car (_vl-times)))
      (setq lw (ssname s 0))
      (vlax-invoke (vlax-ename->vla-object lw) (quote offset) -1e-3)
      (setq lwi (entlast))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (progn
          (rlw lw)
          (entdel lwi)
          (vlax-invoke (vlax-ename->vla-object lw) (quote offset) -1e-3)
          (setq lwi (entlast))
        )
      )
      (setq pl (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) (entget lw))))
      (setq pli (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) (entget lwi))))
      (while (not (equal (car pl) (car pli) 0.1))
        (setq pli (append (cdr pli) (list (car pli))))
      )
      (setq tl (mapcar (function (lambda ( a b ) (list a b))) pl (append (cdr pl) (list (car pl)))))
      (setq utl (unioncollinearplaneprints tl))
      (setq lst (mapcar (function (lambda ( a b c d ) (list a (angle a b) c d))) pl pli (cons (last tl) (reverse (cdr (reverse tl)))) tl))
      (setq llst lst)
      (while (< att 3)
        (if (not att)
          (setq att 1)
          (setq att (1+ att))
        )
        (setq lst llst)
        (setq lil (process lst att))
        (if (= att 1)
          (setq lil1 lil)
          (setq lil2 lil)
        )
      )
      (if (> (length lil1) (length lil2))
        (setq lil lil1)
        (setq lil lil2)
      )
      (foreach li lil
        (if (and (car li) (cadr li) (not (equal (car li) (cadr li) 1e-6)))
          (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li))))
        )
      )
    )
  )
  (*error* nil)
)